#include <cstdio>
#include <cstdlib>
#include <cstdarg>
#include <cctype>

void done(double n, const char *s, ...) {
	fprintf(stdout, "%lf\n", n);
	va_list ap;
	va_start(ap, s);
	vfprintf(stderr, s, ap);
	va_end(ap);
	fprintf(stderr, "\n");
	exit(0);
}

bool blank(const char *s) {
	while (isspace(*s)) {
		++s;
	}
	return *s == 0;
}

char s[100]; int u;
int n, q;
char c; int x1, x2;
int y1, y2;
bool bp = true, bl = true;

int main(int argc, const char *argv[]) {
	if (argc != 4) {
		done(0, "Usage: %s input hint output", argv[0]);
	}

	FILE *in = fopen(argv[1], "rt");
	if (!in) {
		done(0, "Can't open input file %s", argv[1]);
	}
	FILE *hint = fopen(argv[2], "rt");
	if (!hint) {
		done(0, "Can't open hint file %s", argv[2]);
	}
	FILE *out = fopen(argv[3], "rt");
	if (!out) {
		done(0, "Can't open output file %s", argv[3]);
	}

	if (fscanf(in, "%d", &n) != 1) {
		done(0, "Invalid format on line 1 of input file");
	}
	for (int i = 0; i < n; ++i) {
		if (fscanf(in, "%d%d", &x1, &x2) != 2) {
			done(0, "Invalid format on line %d of input file", 2 + i);
		}
	}
	if (fscanf(in, "%d", &q) != 1) {
		done(0, "Invalid format on line %d of input file", 2 + n);
	}
	for (int i = 0; i < q; ++i) {
		if (fscanf(in, " %c%d", &c, &x1) != 2) {
			done(0, "Invalid format on line %d of input file", 2 + n + 1 + i);
		}
		if (fscanf(hint, "%d", &y1) != 1) {
			done(0, "Invalid format on line %d of hint file", 1 + i);
		}
		if (fgets(s, sizeof(s), out) != s) {
			done(0, "Unexpected end of output file");
		}
		if (sscanf(s, "%d%n", &y2, &u) != 1 || !blank(s + u)) {
			done(0, "Invalid format on line %d of output file", 1 + i);
		}
		if (y1 != y2) {
			if (c == 'P') bp = false;
			if (c == 'L') bl = false;
		}
	}
	if (fscanf(out, "%10s", s) > 0) {
		done(0, "Extra data in output file");
	}

	if (bp && bl) {
		done(1, "OK");
	}
	if (bp || bl) {
		done(0.5, "Wrong answers in some queries");
	}
	done(0, "Wrong answers");
}
