#include <iostream>
#include <chrono>
#include <cstring>

using namespace std;
using namespace std::chrono;

#define MAXN 15

int queens[MAXN];

inline bool ischecked(int x1, int y1, int x2, int y2)
{
	return x1 == x2 || y1 == y2 || x2 - x1 == y2 - y1 || x2 - x1 == y1 - y2;
}

int tryrow(int y, int n)
{
	int res = 0;
	for (int x = 0; x < n; x++)
	{
		for (int y1 = 0; y1 < y; y1++)
		{
			if (ischecked(x, y, queens[y1], y1)) goto cont;
		}

		if (y == n - 1)
		{
			res++;
		}
		else
		{
			queens[y] = x;
			res += tryrow(y + 1, n);
		}
	cont:
		;
	}

	return res;
}

void solve(int n)
{
	cout << n << endl;
	high_resolution_clock::time_point t1 = high_resolution_clock::now();
	memset(queens, sizeof(queens), 0);
	int res = tryrow(0, n);
	high_resolution_clock::time_point t2 = high_resolution_clock::now();
	duration<double, std::milli> ms = t2 - t1;

	cout << res << endl;
	cout << ms.count() << endl;
	cout << endl;
}

int main()
{
	for (int n = 4; n <= MAXN; n++)
	{
		solve(n);
	}
}
