#include <iostream>
#include <chrono>
#include <cstring>

using namespace std;
using namespace std::chrono;

#define MAXN 15

// keep track of whether there is a checker on each column, and diagonal
char col[MAXN]; // (i, j) -> j
char updiag[2 * MAXN]; // (i, j) -> i + j
char downdiag[2 * MAXN]; // (i, j) -> i - j + N

int res;
int n;

void tryrow(int i)
{
	if (i == n)
	{
		res++;
		return;
	}

	for (int j = 0; j < n; j++)
	{
		if (!col[j] && !updiag[i + j] && !downdiag[i - j + MAXN])
		{
			col[j]++;
			updiag[i + j]++;
			downdiag[i - j + MAXN]++;

			tryrow(i + 1);

			col[j]--;
			updiag[i + j]--;
			downdiag[i - j + MAXN]--;
		}
	}
}

void solve(int rows)
{
	n = rows;
	cout << n << endl;
	high_resolution_clock::time_point t1 = high_resolution_clock::now();
	res = 0;
	memset(col, sizeof(col), 0);
	memset(updiag, sizeof(updiag), 0);
	memset(downdiag, sizeof(downdiag), 0);
	tryrow(0);
	high_resolution_clock::time_point t2 = high_resolution_clock::now();
	duration<double, std::milli> ms = t2 - t1;

	cout << res << endl;
	cout << ms.count() << endl;
	cout << endl;
}

int main(int argc, char* argv[])
{
	for (int n = 4; n <= MAXN; n++)
	{
		solve(n);
	}
}
