#include <iostream>
#include <chrono>
#include <cstring>

using namespace std;
using namespace std::chrono;

#define MAXN 15

int pr[MAXN + 2]; // previous available column; column numbers 1..n
int nx[MAXN + 2]; // next available column; column numbers 1..n

// keep track of whether there is a checker on each column, and diagonal
char row[MAXN]; // (i, j) -> i
char col[MAXN]; // (i, j) -> j; note that here j=1..n
char updiag[2 * MAXN]; // (i, j) -> i + j; note that here j=1..n
char downdiag[2 * MAXN]; // (i, j) -> i - j + N; note that here j=1..n

int res;
int n;

void tryrow(int i, int lim)
{
	if (i == n)
	{
		res++;
		if (row[0] <= n / 2) res++;
		return;
	}

	for (int j = nx[0]; j <= lim; j = nx[j])
	{
		if (!col[j] && !updiag[i + j] && !downdiag[i - j + MAXN])
		{
			row[i] = j;

			col[j]++;
			updiag[i + j]++;
			downdiag[i - j + MAXN]++;

			nx[pr[j]] = nx[j];
			pr[nx[j]] = pr[j];

			tryrow(i + 1, n);

			nx[pr[j]] = j;
			pr[nx[j]] = j;

			col[j]--;
			updiag[i + j]--;
			downdiag[i - j + MAXN]--;
		}
	}
}

void solve(int rows)
{
	n = rows;
	cout << n << endl;
	high_resolution_clock::time_point t1 = high_resolution_clock::now();
	res = 0;
	for (int i = 0; i <= n + 1; i++)
	{
		pr[i] = i - 1;
		nx[i] = i + 1;
	}
	memset(row, sizeof(row), 0);
	memset(col, sizeof(col), 0);
	memset(updiag, sizeof(updiag), 0);
	memset(downdiag, sizeof(downdiag), 0);
	tryrow(0, (n + 1) / 2);
	high_resolution_clock::time_point t2 = high_resolution_clock::now();
	duration<double, std::milli> ms = t2 - t1;

	cout << res << endl;
	cout << ms.count() << endl;
	cout << endl;
}

int main(int argc, char* argv[])
{
	for (int n = 4; n <= MAXN; n++)
	{
		solve(n);
	}
}
