#include <iostream>
#include <chrono>
using namespace std;
using namespace std::chrono;

#define MAXN 15

int res = 0;

void Nqueen(int board_size) {
	int aQueenBitRes[MAXN]; /* results */
	int aQueenBitCol[MAXN]; /* marks used columns */
	int aQueenBitPosDiag[MAXN]; /* marks used "positive diagonals" */
	int aQueenBitNegDiag[MAXN]; /* marks used "negative diagonals" */
	int aStack[MAXN + 2]; /* a stack instead of recursion */
	int *pnStack;

	int numrows = 0; /* numrows redundant - could use stack */
	unsigned int lsb; /* least significant bit */
	unsigned int bitfield; /* set bits denote possible queen positions */
	int odd = board_size & 1; /* 1 if board_size odd */
	int board_m1 = board_size - 1; /* board size - 1 */
	int mask = (1 << board_size) - 1; /* N bit mask of all 1's */

	aStack[0] = -1; /* sentinel signifies end of stack */
	for (int i = 0; i < (1 + odd); ++i) {
		bitfield = 0;
		if (0 == i) {
			int half = board_size >> 1; /* divide by two */
			bitfield = (1 << half) - 1;
			pnStack = aStack + 1; /* stack pointer */
			aQueenBitRes[0] = 0;
			aQueenBitCol[0] = aQueenBitPosDiag[0] = aQueenBitNegDiag[0] = 0;
		} else {
			bitfield = 1 << (board_size >> 1);
			numrows = 1; /* prob. already 0 */

			aQueenBitRes[0] = bitfield;
			aQueenBitCol[0] = aQueenBitPosDiag[0] = aQueenBitNegDiag[0] = 0;
			aQueenBitCol[1] = bitfield;

			aQueenBitNegDiag[1] = (bitfield >> 1);
			aQueenBitPosDiag[1] = (bitfield << 1);
			pnStack = aStack + 1; /* stack pointer */
			*pnStack++ = 0; /* row done -- only 1 element & we've done it */
			bitfield = (bitfield - 1) >> 1;
			/* bitfield -1 is all 1's to the left of the single 1 */
		}
		for (;;) {
			lsb = -((signed)bitfield) & bitfield;
			if (0 == bitfield) {
				bitfield = *--pnStack; /* get prev. bitfield from stack */
				if (pnStack == aStack) /* if sentinel hit.... */
					break;
				--numrows;
				continue;
			}
			bitfield &= ~lsb; /* bit off -> don't try it again */
			aQueenBitRes[numrows] = lsb; /* save the result */
			if (numrows < board_m1) { /* more rows to process? */
				int n = numrows++;
				aQueenBitCol[numrows] = aQueenBitCol[n] | lsb;
				aQueenBitNegDiag[numrows] = (aQueenBitNegDiag[n] | lsb) >> 1;
				aQueenBitPosDiag[numrows] = (aQueenBitPosDiag[n] | lsb) << 1;
				*pnStack++ = bitfield;
				bitfield = mask & ~(aQueenBitCol[numrows] |
					aQueenBitNegDiag[numrows] | aQueenBitPosDiag[numrows]);
				continue;
			}
			else {
				++res;
				bitfield = *--pnStack;
				--numrows;
				continue;
			}
		}
	}
	res *= 2;
}

void solve(int n) {
	res = 0;
	cout << n << endl;
	high_resolution_clock::time_point t1 = high_resolution_clock::now();
	Nqueen(n);
	high_resolution_clock::time_point t2 = high_resolution_clock::now();
	duration<double, std::milli> ms = t2 - t1;

	cout << res << endl;
	cout << ms.count() << endl;
	cout << endl;
}

int main(int argc, char* argv[]) {
	for (int n = 4; n <= MAXN; n++) {
		solve(n);
	}
}
